        PROGRAM test_ncvgtg

* 8/23/99 *sh*
* test program to compare local and DODS reads of file

#include "netcdf.inc"

        INTEGER cdfid, varid, start(3), count(3), filstride(3),imap(3)
        INTEGER cdfstat, i
        CHARACTER*256 filename
        INTEGER*2 arr2(100000)
        INTEGER*4 arr4(100000)

        varid = 4

        start(1) = 1
        start(2) = 1
        start(3) = 427

        count(1) = 360
        count(2) = 180
        count(3) = 1

        filstride(1) = 1
        filstride(2) = 1
        filstride(3) = 1

* local file access -- succeeds
        imap(1) = 2     ! NCSHORT local data type
        imap(2) = 720
        imap(3) = 129600

* open file
        filename = 'sst.wkmean.1981-1989.nc'

        cdfid = NCOPN(filename, NCNOWRIT, cdfstat)
        write (6,*) 'opened:',cdfstat

* read time step 427
 	   CALL NCVGTG(cdfid, varid, start, count,
     .		   filstride, imap,
     .             arr2, cdfstat)
        write (6,*) 'finished read: ',cdfstat
        write (6,*) (arr2(i),i=1,64800,3600)

****************************

* DODS file access -- crashes
        imap(1) = 4     ! NCLONG (Int32) data type through DODS
        imap(2) = 1440
        imap(3) = 259200

* open file
        filename = 'http://www.cdc.noaa.gov/cgi-bin/nph-nc/Datasets'
     .          //'/reynolds_sst/sst.wkmean.1981-1989.nc'

        cdfid = NCOPN(filename, NCNOWRIT, cdfstat)
        write (6,*) 'opened:',cdfstat

* read time step 427
 	   CALL NCVGTG(cdfid, varid, start, count,
     .		   filstride, imap,
     .             arr4, cdfstat)
        write (6,*) 'finished read: ',cdfstat
        write (6,*) (arr4(i),i=1,64800,3600)


* BACKGROUND INFO
#ifdef(0)
Here is the ncdump of the local file

/export/home/ja3/hankin/tmp> ncdump -h sst.wkmean.1981-1989.nc 
netcdf sst.wkmean.1981-1989 {
dimensions:
        lon = 360 ;
        lat = 180 ;
        time = UNLIMITED ; // (427 currently)
variables:
        float lat(lat) ;
                lat:units = "degrees_north" ;
                lat:long_name = "Latitude" ;
                lat:actual_range = 89.5f, -89.5f ;
        float lon(lon) ;
                lon:units = "degrees_east" ;
                lon:long_name = "Longitude" ;
                lon:actual_range = 0.5f, 359.5f ;
        double time(time) ;
                time:units = "days since 1-1-1 00:00:00" ;
                time:long_name = "Time" ;
                time:actual_range = 723483., 726465. ;
                time:delta_t = "0000-00-07 00:00:00" ;
                time:avg_period = "0000-00-07 00:00:00" ;
        short sst(time, lat, lon) ;
                sst:long_name = "Weekly Means of Sea Surface Temperature" ;
                sst:valid_range = -5.f, 40.f ;
                sst:actual_range = -1.8f, 34.49f ;
                sst:units = "degC" ;
                sst:add_offset = 0.f ;
                sst:scale_factor = 0.01f ;
                sst:missing_value = 32767s ;
                sst:precision = 2s ;
                sst:least_significant_digit = 2s ;
...

********************

Here is the browser output of http://www.cdc.noaa.gov/cgi-bin/nph-nc/Datasets/reynolds_sst/sst.wkmean.1981-1989.nc.dds
Note the change in data type from SHORT to INT32

Dataset {
    Float64 lat[lat = 180];
    Float64 lon[lon = 360];
    Float64 time[time = 427];
    Grid {
     ARRAY:
        Int32 sst[time = 427][lat = 180][lon = 360];
     MAPS:
        Float64 time[time = 427];
        Float64 lat[lat = 180];
        Float64 lon[lon = 360];
    } sst;
    Grid {
     ARRAY:
        Int32 mask[lat = 180][lon = 360];
     MAPS:
        Float64 lat[lat = 180];
        Float64 lon[lon = 360];
    } mask;
} sst.wkmean.1981-1989;

********************************************

And here is the dncdump of it

--to be pasted--

#endif

	END


